/*
 * File:       fibo.c
 * 
 * Author:     M.Rychlik
 *
 * Date:       2008-04-28
 *
 * Decription: Calculation of the 29th member Fibonacci Sequence.
 *             Written as an exercise of the BDS C compiler output running
 *             under an 8080 emulator (propaltair) on the Parallax Propeller
 *             microcontroller. It is performed recursively in the spirit of
 *             DeSilva's (Parallax Inc, propeller forum) benchmark suggestion.
 *             
 *             fibo(29) = 514229  
 *
 *             BDS C has no longs (32 bit) so we have to do this a hard way.
 */

#include "stdio.h"

/* Calculate the nth member of the Fibonacci Sequence and place answere in array result */
fibo_32(n, result)
unsigned n;
unsigned result[2];
{
	unsigned f[2];   
	unsigned temp;

	if (n < 2)
	{
		result[0] = n;			/* Just return n */
		result[1] = 0;
		return;
	}
	else
	{
		fibo_32(n-1, result);		/* Two recursive calls */	
		fibo_32(n-2, f);	
		temp = result[0];		/* Keep this for carry detection */
		result[0] += f[0];		/* Add low 16 bits  */ 
		result[1] += f[1];		/* Add high 16 bits */
		if (result[0] < temp)           /* Bump high 16 bits if carry from low */
		{
			result[1]++;	
		}
		return;
	}
}


/* Calculate the nth member of the Fibonacci Sequence (n less than 25) */
unsigned fibo_16(n)
unsigned n;
{
	if (n < 2)
	{
		return (n);
	}
  	else
	{
    		return (fibo_16(n-1) + fibo_16(n-2));
	}
}


main()
{
	unsigned result[2];	

	printf ("fibo(24) = "); 
/*
	fibo16(24, result);

	printf ("%04x%04x Hexadecimal\n", result[1], result[0]);
*/

	printf ("%04x Hexadecimal\n", fibo_16(24));
	
}
