{{ Upload CPM disk image to SD card with PropTerminal }}
{{ WARNING This will overwright the first megabyte or so of your SD card !!!!}}

CON
  _clkmode = xtal1 + pll8x
  _xinfreq = 10_000_000

  SDpin = 0

VAR
  long filename
  long srcname
  byte buffer[16]
  byte sector_buffer[512]

OBJ
    disk : "sdspiqasm"
    ser  : "FullDuplexSerial"

PUB main
  srcname := string("C:\cpm2.dsk")  'Path and Filename of Sourcefile
  
  ser.start(31,30,0,115200)      'Serial start

  waitcnt(clkfreq*2+cnt)
  ser.tx(0)
  ser.str(string("Upload File to SD card:",13))
  ser.str(string("Press F1 for start",13))

  repeat until ser.rx == $D0     'wait for F1
  getFile                        'Upload

  ser.str(string(13,"done!",13))
  repeat  


PRI getFile  | b, len, n, i, x, ii, sector_idx, block_number

  'LEDs to output
  dira[16..23]~~

  x := \disk.start(0)                      'Start the disk

  waitcnt(clkfreq/4+cnt)

  ser.tx(0)                                'request download sequence:
  ser.str(srcname)                         'send filename
  ser.str(string(5,$82))                   'initiate upload
  ser.tx(strsize(srcname))
  ser.tx("f")
  ser.rxflush  

  b := ser.rxtime(100)                     'PropTerm sends first the FileLength (4 bytes)
  if b => 0
    len := b
    b := ser.rxtime(10)  
    len |= b<<8
    b := ser.rxtime(10)  
    len |= b<<16
    b := ser.rxtime(10)  
    len |= b<<24
    
    n := 0                                 'counter for received bytes
    block_number := 0                      'counter for blocks written
    sector_idx := 0                        'index into sector buffer
    ser.tx(".")                            'trigger sending of first 16 bytes
    repeat
      repeat i from 0 to 15                'receive 16 bytes
        b := ser.rxtime(1000)
        if b<0 or n+i==len                 'quit if length reached
          quit
        buffer[i] := b                     'store in buffer
      if b<0
        quit

      repeat ii from 0 to 15                  'process the 16 bytes
        sector_buffer[sector_idx] := buffer[ii]
        sector_idx++
        if sector_idx == 137                'Do we have an altair disk sectors worth ?
          x := \disk.writeblock(block_number, @sector_buffer)
          block_number++
          outa[16..23] := block_number       'Output the port data

          sector_idx := 0
      '\sd.pwrite(@buffer,16)               'write the buffer to the SD card
      
      if n+i=>len
        quit
      ser.tx(".")                          'trigger next 16 bytes
      n += 16






    